#!/usr/bin/perl -W
#make_theme.pl creates a Hebrew theme for the album program, 
#based on an outline like make_site.pl uses.
#Copyright (C) 2004-2005 Orna Agmon ladypine at haifux.org

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


print "make_theme.pl version 1, Copyright (C) 2004-2005 Orna Agmon\n".
"make_site.pl comes with ABSOLUTELY NO WARRANTY.\n".
"This is free software, and you are welcome\n".
"to redistribute it under certain conditions.\n".
"For details, see http://www.gnu.org/licenses/gpl.txt\n";


use strict;
use English;

my $outdir = "gen/album_theme/simple";
my $absolute="http://granada/aryeh/";
$absolute="http://mulix.org/agmon/";
my $stub;
my $RedUpdate="<em><font color=\"FF0000\" > Update</font></em>";
my $PinkUpdate="<font color=\"FF8383\" > Update</font>";

# open the outline file
open (OUTLINE,"<outline.html") || die ("can't open outline - $!");
my @outline_tmp=(<OUTLINE>);
close (OUTLINE);
my $outline_base=join('',@outline_tmp);

# create the output subdir if it doesn't already exist 
if (! ( -d $outdir )) {
  system "mkdir -p $outdir";
  if (! ( -d $outdir )) {
  
  mkdir($outdir) || die ("can't make output dir $outdir - $!"); 
 }
}

# process the files 
foreach $stub (@ARGV){
  open (IN,"<$stub") || die ("can't open $stub - $!");
  my @page_tmp=(<IN>);
  close(IN);
  my $page=join('',@page_tmp);
  my $html=$stub;
  #prepare names ending with th, which album expects.
  ($html=~s/thp$/th/) or $html.='.th';
  #get the first line, which is heading1 (<h1>), and use it for title.
  #we shave it off for now.
  #later on, we stick it back  inside in the proper place
  #first we shave the <h1> we expect
 
  $page=~s|^\s*\<\s*h1\s*\>||i  
    or die "no heading <h1> for $stub\n";
  #then we seek a closing </h1>. we seperate by it the title.
  # we do not use the following form:
  #  $page=~s|^\s*\<\s*h1\s*\>([^\<]+)\<\s*\/h1\s*\>||i 
  #   or die "no heading for $stub\n";
  #  in order to allow for tags within the title (for links and modifiers- for example, <div dir="rtl">)
  $page=~s|\<\s*\/h1\s*\>||i 
    or die "no heading </h1> for $stub\n";
  my $head=$`;
  $page=$';
  my $site_name = "Aryeh Agmon - The Person and The Artist";
 # my $title = (($head eq $site_name) ? $site_name : "$site_name - $head");
  my $title="$head - $site_name";
  print "$stub, $head\n";
  my $outline=$outline_base;
  #before inserting the current text, fix references to absolute values
  my $acc='';
  while ($outline=~/(href\s*=|src\s*=)(\s*\")([^\"]+)(\")/i){
  	my $url=$3;
	my $prev=$`;
	my $post=$4.$';
	$acc.=$prev.$1.$2;
	if ($url!~m|^http:\/\/|){
		$acc.=$absolute;
	}
	$acc.=$url;
	$outline=$post;	
  }
  $acc.=$outline;
  $outline=$acc;
  
  $outline=~s/InsertTextHere/$page/;
  $outline=~s/InsertHeadHere/$head/;
  $outline=~s/InsertTitleHere/$title/;
  $outline=~s/InsertMetaHere/ <: Meta() :>/;

  
#Find examples, and convert them to text by inserting <br\> before each \n
  while ($outline=~/BeginExampleHere/){
    my $before=$PREMATCH;
    my $rest=$POSTMATCH;
    ($rest=~/EndExampleHere/) or die "example begun but not ended on $stub\n";
    my $after=$POSTMATCH;
    my $example=$PREMATCH;
    $example=~s/\n/\<br \/\>\n/g;
    $outline=$before.$example.$after;
  }
  my $outname = "$outdir/$html";
  open(OUT,">$outname") || die ("can't open output file $outname - $!");
  print OUT $outline;
  close(OUT);
}
